# -*-Mode: makefile;-*-

##
## PIN tools
##

##############################################################
#
# Here are some things you might want to configure
#
##############################################################

include ../../miami.config

##############################################################
#
# Tools - you may wish to add your tool name to TOOL_ROOTS
#
##############################################################


TOOL_ROOTS = cachesim
TOOL_VAR = vars_cache
TOOL_OBJ_DIR = cachesim

PIN_CACHESIM_OBJS = cachetool.o
CACHESIM_OBJS = io.o cache_miami.o load_module.o

COMMON_OBJS = miami_utils.o cache_sim.o
PIN_COMMON_OBJS = on_demand_pin.o use_mpi_rank.o

OA_OBJS = 

TOOLS = $(TOOL_ROOTS:%=$(EXEDIR)%$(PINTOOL_SUFFIX)) 
OBJS = $(CACHESIM_OBJS:%=$(OBJDIR)$(TOOL_OBJ_DIR)/%) $(PIN_CACHESIM_OBJS:%=$(OBJDIR)pinobj/%) \
 $(COMMON_OBJS:%=$(OBJDIR)common/%) $(PIN_COMMON_OBJS:%=$(OBJDIR)pinobj/%) \
 $(OA_OBJS:%=$(OBJDIR)oautils/%)

MAIN_PIN_OBJS = $(PIN_CACHESIM_OBJS:%=$(OBJDIR)pinobj/%)

# finds files for the compiling rules
vpath %.C $(MIAMI_HOME)/src/CacheSim
vpath %.C $(MIAMI_HOME)/src/common

##############################################################
#
# build rules
#
##############################################################

include ../make.rules

.force:

$(OBJDIR): .force
	mkdir -p $(OBJDIR)
	mkdir -p $(OBJDIR)pinobj
	mkdir -p $(OBJDIR)$(TOOL_OBJ_DIR)
	mkdir -p $(OBJDIR)common

$(TOOLS): $(OBJS)

$(TOOLS): %$(PINTOOL_SUFFIX) : $(OBJS)
	$(LINKER) $(TOOL_LDFLAGS) $(DBG) $(LINK_EXE)$@ $(OBJS) $(TOOL_LPATHS) $(TOOL_LIBS)
	@sed -e 's/XTOOLVARX/$(TOOL_VAR)/g' -e 's/XTOOLLIBX/$(TOOL_ROOTS)$(PINTOOL_SUFFIX)/g' $(BINSCRIPT) > $(BINDIR)$(TOOL_ROOTS)
	@chmod +x $(BINDIR)$(TOOL_ROOTS)

